package JUnit;

import org.junit.jupiter.api.MethodOrderer;
import org.junit.jupiter.api.Nested;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.TestMethodOrder;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.junit.jupiter.api.Assertions.assertThrows;

@TestMethodOrder(MethodOrderer.MethodName.class)
class LargestTest {

    @Nested
    class Largest1Tests {
        @Test
        void testLargest11Basic() {
            int[] list = {8, 9, 7};
            int expResult = 9;
            int result = Largest.largest1(list);
            assertEquals(expResult, result, "Largest value in list {8,9,7} should be 9");
        }
    }

    @Nested
    class Largest2Tests {
        @Test
        void testLargest21Basic() {
            int[] list = {8, 9, 7};
            int expResult = 9;
            int result = Largest.largest2(list);
            assertEquals(expResult, result, "Largest value in list {8,9,7} should be 9");
        }

        @Test
        void testLargest22Order() {
            assertEquals(9, Largest.largest2(new int[]{8, 9, 7}), "Largest value in list {8,9,7} should be 9");
            assertEquals(9, Largest.largest2(new int[]{9, 8, 7}), "Largest value in list {9,8,7} should be 9");
            assertEquals(9, Largest.largest2(new int[]{7, 8, 9}), "Largest value in list {7,8,9} should be 9");
        }
    }

    @Nested
    class Largest3Tests {
        @Test
        void testLargest31Basic() {
            int[] list = {8, 9, 7};
            int expResult = 9;
            int result = Largest.largest3(list);
            assertEquals(expResult, result, "Largest value in list {8,9,7} should be 9");
        }

        @Test
        void testLargest32Order() {
            assertEquals(9, Largest.largest3(new int[]{8, 9, 7}), "Largest value in list {8,9,7} should be 9");
            assertEquals(9, Largest.largest3(new int[]{9, 8, 7}), "Largest value in list {9,8,7} should be 9");
            assertEquals(9, Largest.largest3(new int[]{7, 8, 9}), "Largest value in list {7,8,9} should be 9");
        }

        @Test
        void testLargest33Duplicates() {
            assertEquals(9, Largest.largest3(new int[]{9, 7, 8, 9}), "Largest value in list {9,7,8,9} should be 9");
        }

        @Test
        void testLargest34One() {
            assertEquals(9, Largest.largest3(new int[]{9}), "Largest value in list {9} should be 9");
        }

        @Test
        void testLargest35Negative() {
            assertEquals(-7, Largest.largest3(new int[]{-9, -8, -7}), "Largest value in list {-7,-8,-9} should be -7");
        }
    }

    @Nested
    class Largest4Tests {
        @Test
        void testLargest41Basic() {
            int[] list = {8, 9, 7};
            int expResult = 9;
            int result = Largest.largest4(list);
            assertEquals(expResult, result, "Largest value in list {8,9,7} should be 9");
        }

        @Test
        void testLargest42Order() {
            assertEquals(9, Largest.largest4(new int[]{8, 9, 7}), "Largest value in list {8,9,7} should be 9");
            assertEquals(9, Largest.largest4(new int[]{9, 8, 7}), "Largest value in list {9,8,7} should be 9");
            assertEquals(9, Largest.largest4(new int[]{7, 8, 9}), "Largest value in list {7,8,9} should be 9");
        }

        @Test
        void testLargest43Duplicates() {
            assertEquals(9, Largest.largest4(new int[]{9, 7, 8, 9}), "Largest value in list {9,7,8,9} should be 9");
        }

        @Test
        void testLargest44One() {
            assertEquals(9, Largest.largest4(new int[]{9}), "Largest value in list {9} should be 9");
        }

        @Test
        void testLargest45Negative() {
            assertEquals(-7, Largest.largest4(new int[]{-9, -8, -7}), "Largest value in list {-7,-8,-9} should be -7");
        }

        @Test
        void testLargest46Empty() {
            RuntimeException e = assertThrows(RuntimeException.class, () -> {
                Largest.largest4(new int[]{});
            });
            assertEquals("largest: empty list", e.getMessage(), "Expect RuntimeException for empty list usage.");
        }

        @Test
        void testLargest47Null() {
            NullPointerException e = assertThrows(NullPointerException.class, () -> {
                Largest.largest4(null);
            });
            assertEquals("largest: null list", e.getMessage(), "Expect NullPointerException for null list usage.");
        }
    }

    @Nested
    class Largest5Tests {
        @Test
        void testLargest51Basic() {
            int[] list = {8, 9, 7};
            int expResult = 9;
            int result = Largest.largest5(list);
            assertEquals(expResult, result, "Largest value in list {8,9,7} should be 9");
        }

        @Test
        void testLargest52Order() {
            assertEquals(9, Largest.largest5(new int[]{8, 9, 7}), "Largest value in list {8,9,7} should be 9");
            assertEquals(9, Largest.largest5(new int[]{9, 8, 7}), "Largest value in list {9,8,7} should be 9");
            assertEquals(9, Largest.largest5(new int[]{7, 8, 9}), "Largest value in list {7,8,9} should be 9");
        }

        @Test
        void testLargest53Duplicates() {
            assertEquals(9, Largest.largest4(new int[]{9, 7, 8, 9}), "Largest value in list {9,7,8,9} should be 9");
        }

        @Test
        void testLargest54One() {
            assertEquals(9, Largest.largest5(new int[]{9}), "Largest value in list {9} should be 9");
        }

        @Test
        void testLargest55Negative() {
            assertEquals(-7, Largest.largest5(new int[]{-9, -8, -7}), "Largest value in list {-7,-8,-9} should be -7");
        }

        @Test
        void testLargest56Empty() {
            RuntimeException e = assertThrows(RuntimeException.class, () -> {
                Largest.largest5(new int[]{});
            });
            assertEquals("largest: empty list", e.getMessage(), "Expect RuntimeException for empty list usage.");
        }

        @Test
        void testLargest57Null() {
            NullPointerException e = assertThrows(NullPointerException.class, () -> {
                Largest.largest5(null);
            });
            assertEquals("largest: null list", e.getMessage(), "Expect NullPointerException for null list usage.");
        }
    }
}