import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import javax.swing.JPanel;
import javax.swing.Timer;



import java.util.Scanner;
//Author Ethan McCorquodale

/*
 	Version 3/4/2021: I got the graphical portion setup and functional still need to attach it logically
 					  to the World class and have sprites to represent elves/dwarves
 	Version 3/5/2021: I got the sprites setuap correctly, I'm having issues with having them behave correctly though the attack() method
 					  in the World class needs some tweaking I'm pretty sure as it's a logical error that's occurring (orc isn't attacking 
 					  elf after it's told to stop moving when the space it's moving to is occupied)
 	Version 3/9/2021: Finally fixed that weird bug that would cause issues when one entity dies, I did so by adding a sortDead method
 					  at this point the program runs without any bugs and meets the design specifications I just need to add Debug mode now
 */
public class GamePanel extends JPanel implements ActionListener{
	static final int Height = 300;
	static final int Width = 300;
	static final int gridSize = 30;
	static final int elfSize = 15;
	final int Delay = 1;
	int moveCount = 0;
	World world = new World();
	Scanner in = new Scanner(System.in);
	Timer timer;
	GamePanel()	
	{
		this.setPreferredSize(new Dimension(Width,Height));
		this.setBackground(Color.blue);
		this.setFocusable(true);
		this.addKeyListener(new MyKeyAdapter());
		startGame();
	}
	
	public void startGame()	{
		timer = new Timer(Delay,this);
	}
	
	public void paintComponent(Graphics g) {
		super.paintComponent(g);
		drawWorld(g);
	}
	
	public void drawWorld(Graphics g) {
		for (int r = 0; r<world.SIZE;r++) {
			
			for (int c = 0; c<world.SIZE; c++) {
				if(world.aWorld[r][c] == null) {
				g.setColor(Color.white);
				g.fillRect(0+c*gridSize, 0+r*gridSize, gridSize, gridSize);
				g.setColor(Color.black);
				g.drawRect(0+c*gridSize, 0+r*gridSize, gridSize, gridSize);
				} 
				else if(world.aWorld[r][c].getAppearance() == 'E') {
					drawElf(g, c*gridSize, r*gridSize);
				} else if (world.aWorld[r][c].getAppearance() == 'O') {
					drawOrc(g,c*gridSize,r*gridSize);
				}
			}
		}
	}	
	public void drawOrc(Graphics g, int x, int y) {
		
		int[] xCoord = {x+6,x+19,x+elfSize/2+5};
		int[] yCoord = {y+10,y+10,y};
		Color orcGreen = new Color(21,158,26);
		g.setColor(Color.white);
		g.fillRect(x,y, gridSize, gridSize);//sets the background of that grid square white
		g.setColor(orcGreen);
		g.fillOval(x+5, y+7, elfSize, elfSize+3);

		g.setColor(Color.black);
		g.drawOval(x+5, y+7, elfSize, elfSize+3);
		g.setColor(orcGreen);
		g.fillOval(x+13,y+9,5,7);//draws right eye
		g.fillPolygon(xCoord, yCoord, 3);//fills in hat
		g.setColor(Color.black);
		g.drawPolygon(xCoord, yCoord, 3);//draws outline for hat
		g.fillOval(x+7,y+9,5,7);//draws left eye
		g.fillOval(x+13,y+9,5,7);//draws right eye
		
		g.drawLine((x+5)+(elfSize/3), y+elfSize+10, (x+5)+(elfSize/3), y+elfSize+13);//left foot line 1
		g.drawLine((x+5)+(elfSize/3), y+elfSize+13, x+6, y+elfSize+13);//left foot line 2
		g.drawLine((x+5)+elfSize-(elfSize/3), y+elfSize+10, (x+5)+elfSize-(elfSize/3), y+elfSize+13);
		g.drawLine((x+5)+elfSize-(elfSize/3), y+elfSize+13, (x+5)+elfSize-(elfSize/3)+5, y+elfSize+13);
		g.drawRect(x,y, gridSize, gridSize);
		g.drawString("HP: "+world.aWorld[y/gridSize][x/gridSize].getHitPoints(), x, y);
	
	}
	public void drawElf(Graphics g, int x, int y) {
		
		int[] xCoord = {x+5,x+20,x+elfSize/2+5};
		int[] yCoord = {y+7,y+7,y};
		g.setColor(Color.white);
		g.fillRect(x,y, gridSize, gridSize);
		g.setColor(Color.green);
		g.fillRect(x+5, y+7, elfSize, elfSize);
	
		g.fillPolygon(xCoord, yCoord, 3);
		g.setColor(Color.black);
		g.drawPolygon(xCoord, yCoord, 3);
		g.drawRect(x+5, y+7, elfSize, elfSize);
		g.fillOval(x+7,y+9,5,7);
		g.fillOval(x+13,y+9,5,7);
		
		g.drawLine((x+5)+(elfSize/3), y+elfSize+7, (x+5)+(elfSize/3), y+elfSize+13);
		g.drawLine((x+5)+(elfSize/3), y+elfSize+13, x+6, y+elfSize+13);
		g.drawLine((x+5)+elfSize-(elfSize/3), y+elfSize+7, (x+5)+elfSize-(elfSize/3), y+elfSize+13);
		g.drawLine((x+5)+elfSize-(elfSize/3), y+elfSize+13, (x+5)+elfSize-(elfSize/3)+5, y+elfSize+13);
		g.drawRect(x,y, gridSize, gridSize);
		g.drawString("HP: "+world.aWorld[y/gridSize][x/gridSize].getHitPoints(), x, y);
	}
	@Override
	public void actionPerformed(ActionEvent e) {
		world.turnSinceAtk++;
		for (int i = 0; i<world.elfCounter+world.orcCounter+5; i++) {//the +5 stops the case where when multiple entities die the sortDead() breaks by running this more times than it should it finds all elves/orcs separated by a null
			
			if (GameStatus.debugModeOn == false) {
				world.move(i);
			}
		}
		if (GameStatus.debugModeOn) {
			world.move(moveCount);
			repaint();
			timer.stop();
		}
		if(GameStatus.debugModeOn) {
			moveCount++;
			world.turnSinceAtk = 0;//if this doesnt happen cease fire will be met with each entity only moving one at a time
			if(world.loc[moveCount]== null) {
				System.out.println("Cannot move null");//gives output for when the "buffer" +3 is being called in the debug
			}
		}
		
		if (moveCount >= world.orcCounter+world.elfCounter+3) {//the +3 is there for the same reason the +5 is added to the for loop sortDead() sometimes leaves a null between entities and I cant figure out how to fix that so I use this buffer
			moveCount = 0;
		}
		repaint();
		timer.stop();
		if (world.turnSinceAtk >= 10 ) {
			world.programRunning = false;
			System.out.println("Cease Fire, Game over.");
		}
	}
	public class MyKeyAdapter extends KeyAdapter{
		public void keyPressed(KeyEvent e) {
			switch(e.getKeyCode()) {
				case KeyEvent.VK_SPACE:
					if(world.programRunning != false) {
						timer.start();
						break;	
					}else {
						break;
					}

				case KeyEvent.VK_D:
					if(GameStatus.debugModeOn) {
						System.out.println("Debug mode left");
						GameStatus.debugModeOn = false;
						break;
					}
					System.out.println("Debug mode entered");
					GameStatus.debugModeOn = true;
					break;
			}
		}
	}
}