import java.util.Scanner;
//Author Ethan McCorquodale

public class World
{
    public static final int SIZE = 10;
    public static final int ORCS_WIN = 0;
    public static final int ELVES_WIN = 1;
    public static final int DRAW = 2;
    public static final int CEASE_FIRE = 3;
    public static final int NOT_OVER = 4;
    private int i = 0; //creates a local index for the location array in the Display method.
    Location[] loc = new Location[100];//an array that'll track each entities type,location coordinates and if it can move.
    int elfCounter = 0;
    int orcCounter = 0;
    int tempRow = 0;
    int tempColumn = 0;
    int oldRow;
    int oldCol;
    int HP;
    int turnSinceAtk;
    int HPAfter;
    char tempType = ' ';
    public Entity [][] aWorld;
    public boolean programRunning = true;
    
    GameStatus status = new GameStatus();
    // Post-condition: the position of the characters in the
    // starting input file will determine the position of the
    // objects in the array. The type of character in the file
    // determines the appearance of the Entity(O or D) or if the
    // element is empty (spaces become null elements)
    
    public World()
    {
        aWorld = new Entity[SIZE][SIZE];
        int r;
        int c;
        for (r = 0; r < SIZE; r++)//creates each object to null
        {
            for (c = 0; c < SIZE; c++)
            {
                aWorld[r][c] = null;
            }
        }
        aWorld = FileInitialization.read();
        for (r = 0; r < SIZE; r++)
        {
        	System.out.println("");
        	System.out.println(" - "+"- "+"- "+"- "+"- "+"- "+"- "+"- "+"- "+ "- ");
        	for (c = 0; c < SIZE; c++)
            {
        		if (aWorld[r][c] == null) {
        			System.out.print("| ");
        		} else {
        			System.out.print("|"+aWorld[r][c].getAppearance());	
        			if ((aWorld[r][c].getAppearance() == 'O')||(aWorld[r][c].getAppearance() == 'E')) {
        				loc[i] = new Location(r,c,aWorld[r][c].getAppearance());//Initializes each Entities location/type
        				if (loc[i].getType() == 'O') {//this checks the type and counts +1 if it's an orc
        					orcCounter++;
        				} else if (loc[i].getType() == 'E') {
        					elfCounter++;
        				}
        				i++;//Cause each initialization of the loc[i] to go to the next element
        			}
        		}
            }
        	System.out.print("|");
            
        }
        System.out.println();
        System.out.println(" - "+"- "+"- "+"- "+"- "+"- "+"- "+"- "+"- "+ "- ");
        sortLocations();
    }
    public void sortDead() {//supposed to try and sort null elements and bring them to the end doesn't always work as intended
    	for (int i = 0; i<=elfCounter+orcCounter;i++) {
    		if (loc[i] != null) {
    			if((aWorld[loc[i].getRow()][loc[i].getColumn()] == null)&&(loc[i+1] != null)) {
    				loc[i] = loc[i+1];
    				loc[i+1] = null;
    				if(i-2 >= 0) {
    					if(loc[i-2]== null) {
        					sortDead();
        				}	
    				}
    			}
    		}
    	}	
    }
    public void sortLocations() {//puts the elfs in the beginning of the array, checks if there is an orc before and elf and if there is it swaps positions in the array
    	for (int j = 0; j<elfCounter+orcCounter; j++) {
    		if (loc[j+orcCounter] != null) {	
    			if(((loc[j].getType() == 'O')&&(loc[j+orcCounter].getType() == 'E'))) {
        			tempRow = loc[j+orcCounter].getRow();
        			tempColumn = loc[j+orcCounter].getColumn();
        			tempType = loc[j+orcCounter].getType();
        			loc[j+orcCounter].setType(loc[j].getType());
        			loc[j+orcCounter].setColumn(loc[j].getColumn());
        			loc[j+orcCounter].setRow(loc[j].getRow());
        			loc[j].setRow(tempRow);
        			loc[j].setColumn(tempColumn);
        			loc[j].setType(tempType);
        		} 
    		}
    	}
    }
    public void attack(int index) { 
    	if(((loc[index].getType() == 'O')&&(aWorld[tempRow][tempColumn].getAppearance() != 'O'))||((loc[index].getType() == 'E')&&(aWorld[tempRow][tempColumn].getAppearance() != 'E'))) {//makes sure it's not attacking it's own kind
    		turnSinceAtk = 0;
    		if((loc[index].getType() == 'E')&&(aWorld[loc[index].getRow()][loc[index].getColumn()] != null)) {
    			HP = aWorld[tempRow][tempColumn].getHitPoints();
        		aWorld[tempRow][tempColumn].setHitPoints(aWorld[tempRow][tempColumn].getHitPoints()-Entity.ELF_DAMAGE);
    			HPAfter = aWorld[tempRow][tempColumn].getHitPoints();
        		if (GameStatus.debugModeOn) {//attack data for elf attackers
    				status.elfAttackDebug(tempRow, tempColumn, loc[index].getRow(), loc[index].getColumn(),HP,HPAfter);
    			}
        		if (aWorld[tempRow][tempColumn].getHitPoints() <=0) {
        			aWorld[tempRow][tempColumn] = null;
        			orcCounter--;
        			sortDead();
        			if(loc[index] != null) {
        				loc[index].setCanMove(true);
        			}
        			
        			if (orcCounter<=0) {//gives the game an end condition if there's no orcs left
        				System.out.println("Elves win no more orcs left.");
        				programRunning = false;
        				if(GameStatus.debugModeOn) {//lose condition data
        					status.orcLoseDebug(orcCounter);
        				}
        			}
        		}
        	} else if((loc[index].getType() == 'O')&&(aWorld[loc[index].getRow()][loc[index].getColumn()] != null)) {
        		HP = aWorld[tempRow][tempColumn].getHitPoints();
        		aWorld[tempRow][tempColumn].setHitPoints(aWorld[tempRow][tempColumn].getHitPoints()-Entity.ORC_DAMAGE);
        		HPAfter = aWorld[tempRow][tempColumn].getHitPoints();
        		if (GameStatus.debugModeOn) {
    				//attack data for Orc attackers
    				status.orcAttackDebug(tempRow, tempColumn, loc[index].getRow(), loc[index].getColumn(),HP,HPAfter);
    			}
        		if (aWorld[tempRow][tempColumn].getHitPoints() <=0) {
        			aWorld[tempRow][tempColumn] = null;
        			elfCounter--;
        			sortDead();
        			if(loc[index] != null) {
        				loc[index].setCanMove(true);
        			}
        			if (elfCounter<=0) {//gives the game an end condition if there's no Elves left
        				System.out.println("Orcs win no more elves left.");
        				programRunning = false;
        				if(GameStatus.debugModeOn) {//gives data for lose condition when no elves left standing
        					status.elfLoseDebug(elfCounter);
        				}
        			}
        		}
        	} else {
        		loc[index].setCanMove(true);
        	}
    	} else {
    		loc[index].setCanMove(true);
    	}
    }
    public boolean checkPerim(int index) {//looks at all the spaces around the current index of loc[index] looking for things not null
    	if (loc[index] != null) {
    		for(int r = loc[index].getRow()-1; r<loc[index].getRow()+2;r++) {
    			for(int c = loc[index].getColumn()-1; c<loc[index].getColumn()+2;c++ ) {
    				if((r <= 9)&&(c <= 9)&&(r > - 1)&&(c > -1)) {//ensuring r/c is in aWorld
    					if((aWorld[r][c] != null) && (loc[index].getType() != aWorld[r][c].getAppearance())) {
    						
    						loc[index].setCanMove(false);
    						tempRow = r;
    						tempColumn = c;
    						attack(index);
    						return true;
    					}
    				}
    			}
    		}
    		loc[index].setCanMove(true);
    		return false;
    	}
    	return false;
    }
    public void move(int index) {//changes the value of aWorld[][] must set old position to null then update it to the new position.
    	if (checkPerimiter(index) == false) {//checks the perim for things not null if it finds something it returns true and the move code below doesn't run
    		if (loc[index] != null) {
            		if (loc[index].getCanMove()) {
            			if((loc[index].getRow()-1 != -1)&&(loc[index].getColumn()-1 != -1)) {
            				if ((loc[index].getType() == 'E')&&(aWorld[loc[index].getRow()-1][loc[index].getColumn()-1]== null)) {
                        		oldRow = loc[index].getRow();
                        		oldCol = loc[index].getColumn();
                        		loc[index].setRow(oldRow-1);
                        		loc[index].setColumn(oldCol-1);
                        		aWorld[oldRow-1][oldCol-1] = aWorld[oldRow][oldCol];
                        		aWorld[oldRow][oldCol] = null;
                    		}	
            			}
            			if((loc[index].getRow()+1 != 10)&&(loc[index].getColumn()+1 != 10)) {
            				if ((loc[index].getType() == 'O')&&(aWorld[loc[index].getRow()+1][loc[index].getColumn()+1]== null)) {
                        		oldRow = loc[index].getRow();
                        		oldCol = loc[index].getColumn();
                        		loc[index].setRow(oldRow+1);
                        		loc[index].setColumn(oldCol+1);
                        		aWorld[oldRow+1][oldCol+1] = aWorld[oldRow][oldCol];
                        		aWorld[oldRow][oldCol] = null;
                    		}
            			}
            			if ((GameStatus.debugModeOn)&&(loc[index]!= null)) {
                			if (loc[index].getType() == 'E') {//elf move data
                				status.elfMoveDebug(oldRow,oldCol,loc[index].getRow(),loc[index].getRow());
                			} else if (loc[index].getType() == 'O') {//orc move data
                				status.orcMoveDebug(oldRow,oldCol,loc[index].getRow(),loc[index].getRow());
                			}
                		}
                	}
        		}
    	}
    }
}