# CPSC 501, W25, T02
### Devon Harstrom, 30132397

---

### Info:
> Used code from Ethan McCorquodale a classmate who gave permission to use this old code
I then refactored it </br>
> The original code is by Ethan McCorquodale. I was given permission to use it: 
> “... I give you guys (and anyone else who is in the same situation) permission to use this project.” </br>
All refactoring was tested on: </br>
Assignment_1/refactored_code/assignment3GUI - Classmate's/src/refactorTests.java
which tests the world functions to see if the game runs properly 
> other testing was done in the GUI outside of code as it is a GUI based coed

---

#how to run:
> run the java file Simulator.Java in the refactored folder
> enter a txt world file for a basic one enter:
> Assignment_1/refactored_code/assignment3GUI - Classmate's/src/data.txt </br>
> This is the map that the Gui was tested on during the refactoring
> After which a executable will open and you can press 'space' to move to the next turn and 
> 'd' for debug printing to the console if you want

---

### Refactors performed:
> Refactor branch 1: De-nesting code in world (major) </br>
Refactor branch 2: Pulling out methods (major) </br>
Refactor branch 3: Rearrange classes? (major) </br>
Refactor branch 4: Name changes, removing unused code, etc. (small) </br>
Refactor branch 5: Comments (small) </br>

---

### Explanation 

##### Refactor 1:
> Refactor 1 was de-nesting code blocks in the world.java file and class
> The original file had lots of nested code which made the readability and understanding 
> of the code harder. So as a solution I de-nested this by taking the opposite if statements and returning
> if it was true so for example:
```
if(((loc[index].getType() == 'O')&&(aWorld[tempRow][tempColumn].getAppearance() != 'O'))||((loc[index].getType() == 'E')&&(aWorld[tempRow][tempColumn].getAppearance() != 'E'))) {//makes sure it's not attacking it's own kind
    turnSinceAtk = 0;
    if((loc[index].getType() == 'E')&&(aWorld[loc[index].getRow()][loc[index].getColumn()] != null)) {
    //... a bunch more if statements
    }
------------------------------------AFTER------------------------------------------
if(aWorld[tempRow][tempColumn] == null){
    return;
}
if((loc[index].getType() == 'O') && (aWorld[tempRow][tempColumn].getAppearance() == 'O')) {
    return;
}
if((loc[index].getType() == 'E') && (aWorld[tempRow][tempColumn].getAppearance() == 'E')) {
    return;
}
```
> This makes it much easier to read and understand
> I did this for every function in World which includes
> Constructor, sortDead, sortLocations, attack, checkPerim, move


--- 

##### Refactor 2:
> Refactor 2 built off refactor 1 as now that the functions were properly de-nested
> I could separate functions into smaller functions in the World.java file. Adding again to the readability
> split up functions stops some functions from being too long which happened alot in the original code
> For example the move function originally looked like this:
```
public void move(int index) {//changes the value of aWorld[][] must set old position to null then update it to the new position.
    if (checkPerimiter(index) == false) {//checks the perim for things not null if it finds something it returns true and the move code below doesn't run
        if (loc[index] != null) {
                if (loc[index].getCanMove()) {
                    if((loc[index].getRow()-1 != -1)&&(loc[index].getColumn()-1 != -1)) {
                        if ((loc[index].getType() == 'E')&&(aWorld[loc[index].getRow()-1][loc[index].getColumn()-1]== null)) {
                            oldRow = loc[index].getRow();
                            oldCol = loc[index].getColumn();
                            loc[index].setRow(oldRow-1);
                            loc[index].setColumn(oldCol-1);
                            aWorld[oldRow-1][oldCol-1] = aWorld[oldRow][oldCol];
                            aWorld[oldRow][oldCol] = null;
                        }	
                    }
                    if((loc[index].getRow()+1 != 10)&&(loc[index].getColumn()+1 != 10)) {
                        if ((loc[index].getType() == 'O')&&(aWorld[loc[index].getRow()+1][loc[index].getColumn()+1]== null)) {
                            oldRow = loc[index].getRow();
                            oldCol = loc[index].getColumn();
                            loc[index].setRow(oldRow+1);
                            loc[index].setColumn(oldCol+1);
                            aWorld[oldRow+1][oldCol+1] = aWorld[oldRow][oldCol];
                            aWorld[oldRow][oldCol] = null;
                        }
                    }
                    if ((GameStatus.debugModeOn)&&(loc[index]!= null)) {
                        if (loc[index].getType() == 'E') {//elf move data
                            status.elfMoveDebug(oldRow,oldCol,loc[index].getRow(),loc[index].getRow());
                        } else if (loc[index].getType() == 'O') {//orc move data
                            status.orcMoveDebug(oldRow,oldCol,loc[index].getRow(),loc[index].getRow());
                        }
                    }
                }
            }
    	}
    }
```
> which is very long and also has some potential repeate code with:
```
if ((loc[index].getType() == 'E')&&(aWorld[loc[index].getRow()-1][loc[index].getColumn()-1]== null)) {
    oldRow = loc[index].getRow();
    oldCol = loc[index].getColumn();
    loc[index].setRow(oldRow-1);
    loc[index].setColumn(oldCol-1);
    aWorld[oldRow-1][oldCol-1] = aWorld[oldRow][oldCol];
    aWorld[oldRow][oldCol] = null;
}	
```
> so separating functions also allows me to reduce repetitive code, and i can use polymorphism to add to this
> this is what it now look like in refactor 2: 
```
public void moveLogic(char entityType, int index, int increment){
    if ((loc[index].getType() == entityType)&&(aWorld[loc[index].getRow()+ increment][loc[index].getColumn()+increment]== null)) {
        oldRow = loc[index].getRow();
        oldCol = loc[index].getColumn();
        loc[index].setRow(oldRow+increment);
        loc[index].setColumn(oldCol+increment);
        aWorld[oldRow+increment][oldCol+increment] = aWorld[oldRow][oldCol];
        aWorld[oldRow][oldCol] = null;
    }
}
```
> where I can just pass in parameters and have one function.

---

##### Refactor 3:
> Refactor 3 separated the entity class into two subclasses Orcs and Elves
> This allows a better structure in the code and the potential for other entities
> I can also move debug statements to the new subclasses and keep track of entity count 
> in the entity class which makes it easier to understand. 
> here is an example of the old and new entity class with the elf subclass:
```
---------------OLD------------------
//Author Ethan McCorquodale

/*
  Version Feb 17A, 2021
  * Added method so an Entity can damage another Entity.

  Version: Feb 12A, 2021
  * Added attribute to track if Entity has been moved or not.

  Version: Feb 11B, 2021
  * Changed references from dwarves to elves.
  * Added a new damage attribute.

*/

public class Entity
{
    public static final char DEFAULT_APPEARANCE = 'X';
    public static final char ELF = 'E';
    public static final char EMPTY = ' ';
    public static final char ORC = 'O';
    public static final int DEFAULT_HP = 1;
    public static final int ORC_DAMAGE = 3;
    public static final int ELF_DAMAGE = 7;
    public static final int ORC_HP = 10;
    public static final int ELF_HP = 15;

    private char appearance;
    private int hitPoints;
    private int damage;
    
    boolean attacking= false;
    public Entity()
    {
        setAppearance(DEFAULT_APPEARANCE);
        setHitPoints(DEFAULT_HP);
    }

    public Entity(char newAppearance)
    {
        appearance = newAppearance;
        hitPoints = DEFAULT_HP;
        damage = ORC_DAMAGE;
    }

    public Entity(char newAppearance, int newHitPoints, int newDamage)
    {
        setAppearance(newAppearance);
        setDamage(newDamage);
        setHitPoints(newHitPoints);
    }
   /* public void setAtt(boolean isAttacking) {
    	attacking = isAttacking;
    }
    public boolean getAtt() {
    	return attacking;
    }*/
    public char getAppearance()
    {
        return(appearance);
    }

    public int getDamage()
    {
        return(damage);
    }

    public int getHitPoints()
    {
        return(hitPoints);
    }

    public void setAppearance(char newAppearance)//changed this from private to public to change the entity appearance to ' '
    {
        appearance = newAppearance;
    }

    private void setDamage(int newDamage)
    {
        if (newDamage < 1) 
        {
            System.out.println("Damage must be 1 or greater");
        }
        else
        {
            damage = newDamage;
        }        
    }

    public void setHitPoints(int newHitPoints)
    {
        hitPoints = newHitPoints;
    }


}
---------------NEW------------------
public abstract class Entity
{
//    public static final char DEFAULT_APPEARANCE = 'X';
    public static final char EMPTY = ' ';
//    public static final int DEFAULT_HP = 1;

    private char appearance;
    private int hitPoints;
    private int damage;

    private static int orcCounter = 0;
    private static int elfCounter = 0;

    public Entity(char appearance, int hitPoints, int damage) {
        this.appearance = appearance;
        this.hitPoints = hitPoints;
        this.damage = damage;
    }

    public abstract void debugAttack(GameStatus status, int tempRow, int tempColumn, int targetRow, int targetColumn, int HP, int HPAfter);
    public abstract void debugLossConditions(GameStatus status, int entityCounter);

    public char getAppearance()
    {
        return(appearance);
    }

    public int getHitPoints()
    {
        return(hitPoints);
    }

    public void setAppearance(char newAppearance)
    {
        appearance = newAppearance;
    }

    public void setHitPoints(int newHitPoints)
    {
        hitPoints = newHitPoints;
    }

    public int getDamage()
    {
        return(damage);
    }

    public static int getElfCounter() {
        return elfCounter;
    }

    public static int getOrcCounter() {
        return orcCounter;
    }

    public static void incrementElfCounter(int value) {
        elfCounter = elfCounter + value;
    }

    public static void incrementOrcCounter(int value) {
        orcCounter = orcCounter + value;
    }

    public static void setElfCounter(int newElfCounter){
        elfCounter = newElfCounter;
    }

    public static void setOrcCounter(int newOrcCounter){
        orcCounter = newOrcCounter;
    }
}

public class Elf extends Entity {
    public static final char ELF = 'E';
    public static final int ELF_DAMAGE = 7;
    public static final int ELF_HP = 15;

    public Elf() {
        super(ELF, ELF_HP, ELF_DAMAGE);
    }

    @Override
    public void debugAttack(GameStatus status, int tempRow, int tempColumn, int targetRow, int targetColumn, int HP, int HPAfter) {
        status.elfAttackDebug(tempRow, tempColumn, targetRow, targetColumn, HP, HPAfter);
    }

    @Override
    public void debugLossConditions(GameStatus status, int entityCounter){
        status.orcLoseDebug(entityCounter);
    }
}
```
> The same is done what Orc subclass

---

##### Refactor 4:
> refactor 4 was a number of small refactors such as changing names, removing unsless code 
> general warning fixing and writing code more consistently
> This was done across all files. Here are some examples: 
```
Name changing:
    r,c to rows and columns
    i to location index
    g to graphics

Removing unused code:
    public static final int ORCS_WIN = 0;
    public static final int ELVES_WIN = 1;
    public static final int DRAW = 2;
    public static final int CEASE_FIRE = 3;
    public static final int NOT_OVER = 4;
    
Consistent code:
    if(GameStatus.debugModeOn == false) to
    if(GameStatus.debugModeOn)
    
    if(world.programRunning != false) {
        timer.start();
        break;	
    }else {
        break;
    }
    to 
    if(world.programRunning != false) {
        timer.start();
    }
    break;
```
> And much more

--- 

##### Refactor 5
> Refactor 5 is simply commenting to explain code 
> this was mainly done in the world.java file 
> This just helps with readability and understanding 
> for example:

```
// logic for attacking gets health and subtracts the attacking entities damage and sets the new health
and 
deathLogic(attackingEntity, index); // check if attacker killed enemy
victoryLogic(attackingEntity); // check if no enemy remains
and much more
```

---

That is all the Refactoring done on the original code

---

