public class Elf extends Entity {
    public static final char ELF = 'E'; // Elves are represented as an E on the grid
    public static final int ELF_DAMAGE = 7; // damage
    public static final int ELF_HP = 15; // health of each elf

    // elf is a subclass of entity passing in appearance, health and damage
    public Elf() {
        super(ELF, ELF_HP, ELF_DAMAGE);
    }

    // both are the debug statements for attack and loss conditions
    @Override
    public void debugAttack(GameStatus status, int tempRow, int tempColumn, int targetRow, int targetColumn, int HP, int HPAfter) {
        status.elfAttackDebug(tempRow, tempColumn, targetRow, targetColumn, HP, HPAfter);
    }

    @Override
    public void debugLossConditions(GameStatus status, int entityCounter){
        status.elfLoseDebug(entityCounter);
    }

    @Override
    public void debugMovement(GameStatus status, int oldRow, int oldCol, int newRow, int newCol){
        status.elfMoveDebug(oldRow,oldCol,newRow,newCol);
    }
}