public abstract class Entity
{
    //removed unused
    public static final char EMPTY = ' '; // this is for null
    private char appearance; // appearance is O or E
    private int hitPoints; //health
    private final int damage; // damage

    private static int orcCounter = 0; // start at 0
    private static int elfCounter = 0;

    // subclasses are appearance, health, damage
    public Entity(char appearance, int hitPoints, int damage) {
        this.appearance = appearance;
        this.hitPoints = hitPoints;
        this.damage = damage;
    }

    //debug for each subclass
    public abstract void debugAttack(GameStatus status, int tempRow, int tempColumn, int targetRow, int targetColumn, int HP, int HPAfter);
    public abstract void debugLossConditions(GameStatus status, int entityCounter);
    public abstract void debugMovement(GameStatus status, int oldRow, int oldCol, int newRow, int newCol);


    // getter, setter methods, add some more
    public char getAppearance()
    {
        return(appearance);
    }
    public int getHitPoints()
    {
        return(hitPoints);
    }
    public void setAppearance(char newAppearance)
    {
        appearance = newAppearance;
    }
    public void setHitPoints(int newHitPoints)
    {
        hitPoints = newHitPoints;
    }
    public int getDamage()
    {
        return(damage);
    }
    public static int getElfCounter() {
        return elfCounter;
    }
    public static int getOrcCounter() {
        return orcCounter;
    }
    public static void incrementElfCounter(int value) {
        elfCounter = elfCounter + value;
    }
    public static void incrementOrcCounter(int value) {
        orcCounter = orcCounter + value;
    }
    public static void setElfCounter(int newElfCounter){
        elfCounter = newElfCounter;
    }
    public static void setOrcCounter(int newOrcCounter){
        orcCounter = newOrcCounter;
    }
}

