import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import javax.swing.JPanel;
import javax.swing.Timer;
// removed unused import

//Author Ethan McCorquodale

/*
 	Version 3/4/2021: I got the graphical portion setup and functional still need to attach it logically
 					  to the World class and have sprites to represent elves/dwarves
 	Version 3/5/2021: I got the sprites setup correctly, I'm having issues with having them behave correctly though the attack() method
 					  in the World class needs some tweaking I'm pretty sure as it's a logical error that's occurring (orc isn't attacking
 					  elf after it's told to stop moving when the space it's moving to is occupied)
 	Version 3/9/2021: Finally fixed that weird bug that would cause issues when one entity dies, I did so by adding a sortDead method
 					  at this point the program runs without any bugs and meets the design specifications I just need to add Debug mode now
 */

// this file draws the game in the GUI and handles the "space key interaction"
public class GamePanel extends JPanel implements ActionListener{
	static final int Height = 300;
	static final int Width = 300;
	static final int gridSize = 30;
	static final int elfSize = 15;
	final int Delay = 1;
	int moveCount = 0;
	World world = new World();
	Timer timer;
	GamePanel()
	{
		this.setPreferredSize(new Dimension(Width,Height));
		this.setBackground(Color.blue);
		this.setFocusable(true);
		this.addKeyListener(new MyKeyAdapter());
		startGame();
	}

	public void startGame()	{
		timer = new Timer(Delay,this);
	}

	public void paintComponent(Graphics graphics) { // changed g to graphics since I don't like single letter variables
		super.paintComponent(graphics);
		drawWorld(graphics);
	}

	public void drawWorld(Graphics graphics) {
		for (int row = 0; row<World.SIZE;row++) { //fixed static warning
			for (int column = 0; column<World.SIZE; column++) {
				if(world.aWorld[row][column] == null) {
					graphics.setColor(Color.white);
					graphics.fillRect(column*gridSize, row*gridSize, gridSize, gridSize); // removed unnecessary 0+
					graphics.setColor(Color.black);
					graphics.drawRect(column*gridSize, row*gridSize, gridSize, gridSize); // removed unnecessary 0+
				}
				else if(world.aWorld[row][column].getAppearance() == 'E') {
					drawElf(graphics, column*gridSize, row*gridSize);
				} else if (world.aWorld[row][column].getAppearance() == 'O') {
					drawOrc(graphics,column*gridSize,row*gridSize);
				}
			}
		}
	}
	public void drawOrc(Graphics graphics, int x, int y) {

		int[] xCoord = {x+6,x+19,x+elfSize/2+5};
		int[] yCoord = {y+10,y+10,y};
		Color orcGreen = new Color(21,158,26);
		graphics.setColor(Color.white);
		graphics.fillRect(x,y, gridSize, gridSize);//sets the background of that grid square white
		graphics.setColor(orcGreen);
		graphics.fillOval(x+5, y+7, elfSize, elfSize+3);

		graphics.setColor(Color.black);
		graphics.drawOval(x+5, y+7, elfSize, elfSize+3);
		graphics.setColor(orcGreen);
		graphics.fillOval(x+13,y+9,5,7);//draws right eye
		graphics.fillPolygon(xCoord, yCoord, 3);//fills in hat
		graphics.setColor(Color.black);
		graphics.drawPolygon(xCoord, yCoord, 3);//draws outline for hat
		graphics.fillOval(x+7,y+9,5,7);//draws left eye
		graphics.fillOval(x+13,y+9,5,7);//draws right eye

		graphics.drawLine((x+5)+(elfSize/3), y+elfSize+10, (x+5)+(elfSize/3), y+elfSize+13);//left foot line 1
		graphics.drawLine((x+5)+(elfSize/3), y+elfSize+13, x+6, y+elfSize+13);//left foot line 2
		graphics.drawLine((x+5)+elfSize-(elfSize/3), y+elfSize+10, (x+5)+elfSize-(elfSize/3), y+elfSize+13);
		graphics.drawLine((x+5)+elfSize-(elfSize/3), y+elfSize+13, (x+5)+elfSize-(elfSize/3)+5, y+elfSize+13);
		graphics.drawRect(x,y, gridSize, gridSize);
		graphics.drawString("HP: "+world.aWorld[y/gridSize][x/gridSize].getHitPoints(), x, y);

	}
	public void drawElf(Graphics graphics, int x, int y) {

		int[] xCoord = {x+5,x+20,x+elfSize/2+5};
		int[] yCoord = {y+7,y+7,y};
		graphics.setColor(Color.white);
		graphics.fillRect(x,y, gridSize, gridSize);
		graphics.setColor(Color.green);
		graphics.fillRect(x+5, y+7, elfSize, elfSize);

		graphics.fillPolygon(xCoord, yCoord, 3);
		graphics.setColor(Color.black);
		graphics.drawPolygon(xCoord, yCoord, 3);
		graphics.drawRect(x+5, y+7, elfSize, elfSize);
		graphics.fillOval(x+7,y+9,5,7);
		graphics.fillOval(x+13,y+9,5,7);

		graphics.drawLine((x+5)+(elfSize/3), y+elfSize+7, (x+5)+(elfSize/3), y+elfSize+13);
		graphics.drawLine((x+5)+(elfSize/3), y+elfSize+13, x+6, y+elfSize+13);
		graphics.drawLine((x+5)+elfSize-(elfSize/3), y+elfSize+7, (x+5)+elfSize-(elfSize/3), y+elfSize+13);
		graphics.drawLine((x+5)+elfSize-(elfSize/3), y+elfSize+13, (x+5)+elfSize-(elfSize/3)+5, y+elfSize+13);
		graphics.drawRect(x,y, gridSize, gridSize);
		graphics.drawString("HP: "+world.aWorld[y/gridSize][x/gridSize].getHitPoints(), x, y);
	}
	@Override
	public void actionPerformed(ActionEvent e) {
		world.turnSinceAtk++;
		for (int i = 0; i<Entity.getElfCounter()+Entity.getOrcCounter()+5; i++) {//the +5 stops the case where when multiple entities die the sortDead() breaks by running this more times than it should it finds all elves/orcs separated by a null

			if (!GameStatus.debugModeOn) { //switched, still checking if false
				world.move(i);
			}
		}
		if (GameStatus.debugModeOn) {
			world.move(moveCount);
			repaint();
			timer.stop();
		}
		if(GameStatus.debugModeOn) {
			moveCount++;
			world.turnSinceAtk = 0;//if this doesn't happen cease fire will be met with each entity only moving one at a time
			if(world.location[moveCount]== null) {
				System.out.println("Cannot move null");//gives output for when the "buffer" +3 is being called in the debug
			}
		}

		if (moveCount >= Entity.getOrcCounter()+Entity.getElfCounter()+3) {//the +3 is there for the same reason the +5 is added to the for loop sortDead() sometimes leaves a null between entities and I cant figure out how to fix that so, I use this buffer
			moveCount = 0;
		}
		repaint();
		timer.stop();
		if (world.turnSinceAtk >= 10 ) {
			world.programRunning = false;
			System.out.println("Cease Fire, Game over.");
		}
	}

	public class MyKeyAdapter extends KeyAdapter{
		public void keyPressed(KeyEvent e) {
			switch(e.getKeyCode()) {
				case KeyEvent.VK_SPACE:
					if(world.programRunning) { // switched it, but it's still true // fixed accidentally set to false
						timer.start();
					}
					break; // else was unnecessary

				case KeyEvent.VK_D:
					if(GameStatus.debugModeOn) {
						System.out.println("Debug mode left");
						GameStatus.debugModeOn = false;
						break;
					}
					System.out.println("Debug mode entered");
					GameStatus.debugModeOn = true;
					break;
			}
		}
	}
}