import org.junit.jupiter.api.Test;
import java.io.ByteArrayInputStream;
import java.io.InputStream;
import static org.junit.jupiter.api.Assertions.*;
import org.junit.jupiter.api.*;

class refactorTests {
    private static World world;

    @BeforeEach
    void setUp() {
        Entity.setOrcCounter(0);
        Entity.setElfCounter(0);
    }
//        String simulatedInput = "Assignment_1/original_code/assignment3GUI - Classmate's/src/data.txt";
////        String simulatedInput = "Assignment_1/refactored_code/assignment3GUI - Classmate's/src/attackTest.txt\n";
//        InputStream originalSystemInStream = System.in;  // Save the original System.in
//        ByteArrayInputStream simulatedInputStream = new ByteArrayInputStream(simulatedInput.getBytes());
//        System.setIn(simulatedInputStream);  // Set System.in to the new input stream
//        world = new World();  // This will call FileInitialization.read() and use the simulated input
//        System.setIn(originalSystemInStream);  // Restore the original System.in


    @Test
    void testBoardInitialization() {
        String simulatedInput = "Assignment_1/original_code/assignment3GUI - Classmate's/src/data.txt";
//        String simulatedInput = "Assignment_1/refactored_code/assignment3GUI - Classmate's/src/attackTest.txt\n";
        // note chatgpt helped with the system.in portion as i wasn't sure how to enter into terminal though code
        InputStream originalSystemInStream = System.in;  // Save the original System.in
        ByteArrayInputStream simulatedInputStream = new ByteArrayInputStream(simulatedInput.getBytes());
        System.setIn(simulatedInputStream);  // Set System.in to the new input stream
        world = new World();  // This will call FileInitialization.read() and use the simulated input
        System.setIn(originalSystemInStream);  // Restore the original System.in

        System.out.println("Test 1 running.");
        assertNotNull(world.aWorld, "Board should be initialized");
        assertEquals(World.SIZE, world.aWorld.length, "Board should have correct rows");
        assertEquals(World.SIZE, world.aWorld[0].length, "Board should have correct columns");
        assertEquals(4, Entity.getElfCounter()); // check if right amount of elves and orcs
        assertEquals(4, Entity.getOrcCounter());
    }

    @Test
    void sortDeadTest(){
        String simulatedInput = "Assignment_1/original_code/assignment3GUI - Classmate's/src/data.txt";
//        String simulatedInput = "Assignment_1/refactored_code/assignment3GUI - Classmate's/src/attackTest.txt\n";
        // note chatgpt helped with the system.in portion as i wasn't sure how to enter into terminal though code
        InputStream originalSystemInStream = System.in;  // Save the original System.in
        ByteArrayInputStream simulatedInputStream = new ByteArrayInputStream(simulatedInput.getBytes());
        System.setIn(simulatedInputStream);  // Set System.in to the new input stream
        world = new World();  // This will call FileInitialization.read() and use the simulated input
        System.setIn(originalSystemInStream);  // Restore the original System.in

        world.sortDead();
        assertNull(world.location[world.location.length - 1]);
        assertNull(world.location[world.location.length - 2]);
        assertNull(world.location[world.location.length - 20]);
        System.out.println(world.location[world.location.length - 20]);
    }

    @Test
    void testSort(){
        String simulatedInput = "Assignment_1/original_code/assignment3GUI - Classmate's/src/data.txt";
//        String simulatedInput = "Assignment_1/refactored_code/assignment3GUI - Classmate's/src/attackTest.txt\n";
        InputStream originalSystemInStream = System.in;  // Save the original System.in
        ByteArrayInputStream simulatedInputStream = new ByteArrayInputStream(simulatedInput.getBytes());
        System.setIn(simulatedInputStream);  // Set System.in to the new input stream
        world = new World();  // This will call FileInitialization.read() and use the simulated input
        System.setIn(originalSystemInStream);  // Restore the original System.in
        //in data.txt the sorted array should be OOEEOOEE
        StringBuilder afterSort = new StringBuilder();
        for (Location location : world.location) {
            afterSort.append(location != null ? location.getType() : "");
        }
        assertEquals("OOEEOOEE", afterSort.toString(), "Locations should be sorted like this");
    }

    @Test
    void testAttack(){
        // create world and tell them to attack
        String simulatedInput = "Assignment_1/refactored_code/assignment3GUI - Classmate's/src/attackTest.txt\n";
        InputStream originalSystemInStream = System.in;  // Save the original System.in
        ByteArrayInputStream simulatedInputStream = new ByteArrayInputStream(simulatedInput.getBytes());
        System.setIn(simulatedInputStream);  // Set System.in to the new input stream
        world = new World();  // This will call FileInitialization.read() and use the simulated input
        System.setIn(originalSystemInStream);  // Restore the original System.in

        world.tempRow = 0;
        world.tempColumn = 0;
        world.attack(0); //elf will attack
        int Hp = world.aWorld[world.location[1].getRow()][world.location[1].getColumn()].getHitPoints();
        System.out.println("health after attack: " + Hp);
        assertTrue(world.aWorld[world.location[1].getRow()][world.location[1].getColumn()].getHitPoints() < 10, "Orc should lose HP after attack");
    }

    @Test
    void checkPerimeterTest(){
        String simulatedInput = "Assignment_1/refactored_code/assignment3GUI - Classmate's/src/perimTest.txt\n";
        InputStream originalSystemInStream = System.in;  // Save the original System.in
        ByteArrayInputStream simulatedInputStream = new ByteArrayInputStream(simulatedInput.getBytes());
        System.setIn(simulatedInputStream);  // Set System.in to the new input stream
        world = new World();  // This will call FileInitialization.read() and use the simulated input
        System.setIn(originalSystemInStream);  // Restore the original System.in

        assertTrue(world.checkPerimeter(0), "should be true, something next to the elf");
        assertTrue(world.checkPerimeter(1), "should be true, something next to the orc");
        assertFalse(world.checkPerimeter(2), "should be false, nothing next to the elf");
        assertFalse(world.checkPerimeter(3), "should be false, spot is null");
    }

    @Test
    void testMove(){
        String simulatedInput = "Assignment_1/refactored_code/assignment3GUI - Classmate's/src/moveTest.txt\n";
        InputStream originalSystemInStream = System.in;  // Save the original System.in
        ByteArrayInputStream simulatedInputStream = new ByteArrayInputStream(simulatedInput.getBytes());
        System.setIn(simulatedInputStream);  // Set System.in to the new input stream
        world = new World();  // This will call FileInitialization.read() and use the simulated input
        System.setIn(originalSystemInStream);  // Restore the original System.in

        assertEquals('O', world.aWorld[0][0].getAppearance(), "should be an Orc at 0,0");
        System.out.println(world.aWorld[0][0].getAppearance()+ " at: 0:0");
        world.move(1);
        assertEquals('O', world.aWorld[1][1].getAppearance(), "should be an Orc");
        System.out.println(world.aWorld[1][1].getAppearance() + " at: 1:1, from move function" );

    }

    @Test
    void testEntities(){
        Entity testElfEntity = new Elf();
        Entity testOrcEntity = new Orc();

        assertNotNull(testElfEntity, "should not be null");
        assertNotNull(testOrcEntity, "should not be null");

        assertEquals('E', testElfEntity.getAppearance());
        assertEquals('O', testOrcEntity.getAppearance());

        assertEquals(7, testElfEntity.getDamage());
        assertEquals(3, testOrcEntity.getDamage());

        assertEquals(15, testElfEntity.getHitPoints());
        assertEquals(10, testOrcEntity.getHitPoints());
    }

    @Test
    void testEntityCounters() {
        assertEquals(0, Entity.getElfCounter());
        assertEquals(0, Entity.getOrcCounter());

        Entity.incrementElfCounter(5);
        Entity.incrementOrcCounter(-1);

        assertEquals(5, Entity.getElfCounter());
        assertEquals(-1, Entity.getOrcCounter());

        Entity.setElfCounter(0);
        Entity.setOrcCounter(0);

        assertEquals(0, Entity.getElfCounter());
        assertEquals(0, Entity.getOrcCounter());
    }
}