class Employee {
    public double calculateSalary(WorkDetails workDetails) {
        return getTotalSalary(workDetails);
    }

    public double getRegularSalary(WorkDetails workDetails){
        return workDetails.getHoursWorked() * workDetails.getHourlyRate();
    }

    public double getOvertimeSalary(WorkDetails workDetails){
        if (workDetails.getHoursWorked() > 40) {
            return (workDetails.getHoursWorked() - 40) * (workDetails.getHourlyRate() * 1.5); // Temporary variable for overtime salary
        }
        return 0;
    }

    public double getTotalSalary(WorkDetails workDetails){
        return getRegularSalary(workDetails) + getOvertimeSalary(workDetails);
    }

    public static void main(String[] args) {
        Employee employee = new Employee();
        WorkDetails workDetails = new WorkDetails(45, 20);
        System.out.println("Total salary: " + employee.calculateSalary(workDetails));
    }
}