public class OrderProcessor {
    public void processOrder(String customerName, String item, int quantity, double price) {
        System.out.println("Processing order for: " + customerName);

        double totalPrice = calculateTotalPrice(quantity, price);

        if(!checkStock(quantity, item)){
            return;
        }

        processPayment(totalPrice);

        shipOrder(customerName, item);
    }

    public static void main(String[] args) {
        OrderProcessor processor = new OrderProcessor();
        processor.processOrder("Alice", "Laptop", 2, 750.00);
    }

    private double calculateTotalPrice(int quantity, double price) {
        // Calculate total price
        double totalPrice = quantity * price;
        System.out.println("Total price: $" + totalPrice);
        return totalPrice;
    }

    private boolean checkStock(int quantity, String item){
        // Check stock
        if (quantity > 10) {
            System.out.println("Insufficient stock for " + item);
            return false;
        }
        return true;
    }

    private void processPayment(double totalPrice){
        // Process payment
        System.out.println("Processing payment...");
        if (totalPrice > 1000) {
            System.out.println("High-value transaction! Notifying manager...");
        }
        System.out.println("Payment successful.");
    }

    private void shipOrder(String customerName, String item){
        // Ship order
        System.out.println("Preparing " + item + " for shipping...");
        System.out.println("Order for " + customerName + " has been shipped.");
    }

}

